require( "iuplua" )
require( "iupluacontrols" )
local ui = {}

local help_text = 'TGFT_Utilities v'..tgft_utils.version..'\n'..
"-- NOTE:  Some commands are restricted to TGFT guild members only. --\n"..
"search\t\tSearch for Items in VO.  /search tiles | /search neutron\n"..
"botsearch\t\tSearch for locations of bots.  /botsearch kannik | /botsearch guardian\n"..
'lowprice\t\tLookup lowest price of items.  /lowprice plasteel | /lowprice "phase blaster"\n'..
'highprice\t\tLookup highest price of items.  /highprice plasteel | /highprice "phase blaster"\n'..
"mydent\t\tPlot to the sector that your Trident is parked in.\n" ..
"targetdent\t\tSpecifies what Trident you wish to relate to.  Used for when multiple Tridents are in a sector.\n"..
"\t\t\tFirst target the Trident you wish to relate to, then use /targetdent.  Then everytime you do /targetdent after that, you will target that Trident.\n"..
"stations\t\tSearch Stations.  /stations dau | /stations biocom | /stations Orbital\n"..
'players\t\tList where a player was seen.  /players lisa | /players edras | players "latos h-2" | /players famy\n'..
"guilditem\t\tUpdate the list of items available to other guild members.\n"..
'lowsystem\t\tLookup lowest price of items in a system.  /lowprice plasteel dau | /lowprice "phase blaster" nyrius\n'..
'highsystem\t\tLookup highest price of items in a system.  /highprice plasteel dau | /highprice "phase blaster" nyrius\n'..
"autounload\t\tToggle auto-unloading.  Used to drop cargo in a station fast, unloads, then launches your ship.\n"..
"\t\t\tCan be useful for station takes when reloading in a trident.  It will launch you as soon as you dock.\n"..
"hostile\t\t\tAdd or remove a person/guild to our hostile list.\n"..
"app\t\t\tAdd or remove a  person from out applicants list.\n"..
"\t\t\tAdd a player to the applicants list:  /app + theplayer\n"..
"\t\t\tMark a player as ready for Interview:  /app i theplayer\n"..
"\t\t\tMark a player as a probie:  /app p theplayer\n"..
"\t\t\tRemove a player from the app list:  /app - theplayer\n"..
"turbotoggle\tToggle turbo on and off.  Use a bind such as /bind T turbotoggle\n"..
"launch\t\tLaunch your ship.  Bind it with /bind L launch\n"..
"tgft_init\t\tRe-Initialize the plugin.\n"..
"bindsave\t\tTells VO to save the binds you have in place.\n"..
"alarm\t\t\tToggles the reporting of your Trident attacks to guild chat."

function ui:ShowHelp()
	StationHelpDialog:Open(help_text)
end

function ui:ShowOutput(data)
	StationHelpDialog:Open(data)
end

local button_help = iup.stationbutton{title="Help", hotkey=iup.K_h, action=ui.ShowHelp}
local button_ok = iup.stationbutton{title="OK"}
	
local lisaframe = iup.vbox{
	iup.hbox{iup.fill{}, iup.label{title="TGFT Utilities "..tgft_utils.version,font=Font.H3}, iup.fill{}},
	iup.fill{size=20},
	iup.hbox{iup.fill{size=12}, options_box, iup.fill{}, gap=8},
	iup.fill{size=8},
	iup.hbox{button_help, iup.fill{}, button_ok, gap=8},
	alignment="ACENTER",
}
	
	-- Create Dialog --
ui.dialog = iup.dialog{
	iup.vbox{
		iup.fill{},
		iup.hbox{
			iup.fill{},
			iup.stationhighopacityframe{
				iup.stationhighopacityframebg{
					lisaframe,
					expand="NO",
					gap=8,
				},
			},
			iup.fill{},
		},
		iup.fill{},
	},
	BGCOLOR = "0 0 0 160 *",
	FULLSCREEN="NO",
	RESIZE="NO",
	BORDER="NO",
	MENUBOX="YES",
	TOPMOST="YES",
	DEFAULTESC=button_ok,
	DEFAULTENTER=button_ok,
}

ui.dialog:map()
	
function ui:Show()
	ui.Update(self) --reset control values in case of changed by console
	ShowDialog(ui.dialog,iup.CENTER,iup.CENTER)
	iup.Refresh(ui.dialog)
end
	
	--capture state of controls and save to config
function ui:Hide()
	HideDialog(ui.dialog)
end
	
function button_ok.action() 
	ui.Hide(button_ok) 
end

return ui
		
